diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/legacy/hd.c linux-2.4.22-ashuariadevel/drivers/ide/legacy/hd.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/legacy/hd.c	2003-06-13 23:51:33.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/legacy/hd.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 104,110 ****
  #endif
  
  static struct hd_struct hd[MAX_HD<<6];
! static int hd_sizes[MAX_HD<<6];
  static int hd_blocksizes[MAX_HD<<6];
  static int hd_hardsectsizes[MAX_HD<<6];
  static int hd_maxsect[MAX_HD<<6];
--- 104,110 ----
  #endif
  
  static struct hd_struct hd[MAX_HD<<6];
! static sector_t hd_sizes[MAX_HD<<6];
  static int hd_blocksizes[MAX_HD<<6];
  static int hd_hardsectsizes[MAX_HD<<6];
  static int hd_maxsect[MAX_HD<<6];
***************
*** 817,823 ****
  		hd[drive<<6].nr_sects = hd_info[drive].head *
  			hd_info[drive].sect * hd_info[drive].cyl;
  		printk ("hd%c: %ldMB, CHS=%d/%d/%d\n", drive+'a',
! 			hd[drive<<6].nr_sects / 2048, hd_info[drive].cyl,
  			hd_info[drive].head, hd_info[drive].sect);
  	}
  	if (!NR_HD)
--- 817,823 ----
  		hd[drive<<6].nr_sects = hd_info[drive].head *
  			hd_info[drive].sect * hd_info[drive].cyl;
  		printk ("hd%c: %ldMB, CHS=%d/%d/%d\n", drive+'a',
! 			(long)hd[drive<<6].nr_sects / 2048, hd_info[drive].cyl,
  			hd_info[drive].head, hd_info[drive].sect);
  	}
  	if (!NR_HD)
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/legacy/pdc4030.c linux-2.4.22-ashuariadevel/drivers/ide/legacy/pdc4030.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/legacy/pdc4030.c	2003-08-25 20:44:41.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/legacy/pdc4030.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 434,441 ****
  #endif /* CONFIG_IDE_TASKFILE_IO */
  
  #ifdef DEBUG_READ
! 	printk(KERN_DEBUG "%s:  promise_read: sectors(%ld-%ld), "
! 	       "buf=0x%08lx, rem=%ld\n", drive->name, rq->sector,
  	       rq->sector+nsect-1,
  #ifdef CONFIG_IDE_TASKFILE_IO
  		(unsigned long) to,
--- 434,441 ----
  #endif /* CONFIG_IDE_TASKFILE_IO */
  
  #ifdef DEBUG_READ
! 	printk(KERN_DEBUG "%s:  promise_read: sectors(%llu-%llu), "
! 	       "buf=0x%08lx, rem=%lu\n", drive->name, rq->sector,
  	       rq->sector+nsect-1,
  #ifdef CONFIG_IDE_TASKFILE_IO
  		(unsigned long) to,
***************
*** 654,660 ****
  	struct request *rq = &hwgroup->wrq;
  
  #ifdef DEBUG_WRITE
! 	printk(KERN_DEBUG "%s: promise_write: sectors(%ld-%ld), "
  	       "buffer=%p\n", drive->name, rq->sector,
  	       rq->sector + rq->nr_sectors - 1, rq->buffer);
  #endif /* DEBUG_WRITE */
--- 654,660 ----
  	struct request *rq = &hwgroup->wrq;
  
  #ifdef DEBUG_WRITE
! 	printk(KERN_DEBUG "%s: promise_write: sectors(%llu-%llu), "
  	       "buffer=%p\n", drive->name, rq->sector,
  	       rq->sector + rq->nr_sectors - 1, rq->buffer);
  #endif /* DEBUG_WRITE */
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/ide/raid/ataraid.c linux-2.4.22-ashuariadevel/drivers/ide/raid/ataraid.c
*** linux-2.4.22-ashuariadevel.backup/drivers/ide/raid/ataraid.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/ide/raid/ataraid.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 47,53 ****
  
  
  struct gendisk ataraid_gendisk;
! static int ataraid_gendisk_sizes[256];
  static int ataraid_readahead[256];
  
  static struct block_device_operations ataraid_fops = {
--- 47,53 ----
  
  
  struct gendisk ataraid_gendisk;
! static sector_t ataraid_gendisk_sizes[256];
  static int ataraid_readahead[256];
  
  static struct block_device_operations ataraid_fops = {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/linear.c linux-2.4.22-ashuariadevel/drivers/md/linear.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/linear.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/linear.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 32,39 ****
  	linear_conf_t *conf;
  	struct linear_hash *table;
  	mdk_rdev_t *rdev;
! 	int size, i, j, nb_zone;
! 	unsigned int curr_offset;
  
  	MOD_INC_USE_COUNT;
  
--- 32,40 ----
  	linear_conf_t *conf;
  	struct linear_hash *table;
  	mdk_rdev_t *rdev;
! 	s64 size;
! 	int i, j, nb_zone;
! 	sector_t curr_offset;
  
  	MOD_INC_USE_COUNT;
  
***************
*** 54,63 ****
--- 55,70 ----
  	curr_offset = 0;
  	ITERATE_RDEV_ORDERED(mddev,rdev,j) {
  		dev_info_t *disk = conf->disks + j;
+ 		long x;
  
  		disk->dev = rdev->dev;
  		disk->size = rdev->size;
  		disk->offset = curr_offset;
+ 		x = disk->size;
+ 		if (unlikely((sector_t)x != disk->size)) {
+ 			printk("linear: Array members must be smaller than 2TB, aborting\n");
+ 			goto out;
+ 		}
  
  		curr_offset += disk->size;
  
***************
*** 65,74 ****
  			conf->smallest = disk;
  	}
  
! 	nb_zone = conf->nr_zones =
! 		md_size[mdidx(mddev)] / conf->smallest->size +
! 		((md_size[mdidx(mddev)] % conf->smallest->size) ? 1 : 0);
!   
  	conf->hash_table = kmalloc (sizeof (struct linear_hash) * nb_zone,
  					GFP_KERNEL);
  	if (!conf->hash_table)
--- 72,85 ----
  			conf->smallest = disk;
  	}
  
! 
! 
! 	{
! 		sector_t sz = md_size[mdidx(mddev)];
! 		unsigned round = sector_div(sz, (long)conf->smallest->size);
! 		nb_zone = conf->nr_zones = sz + (round != 0);
! 	}
! 
  	conf->hash_table = kmalloc (sizeof (struct linear_hash) * nb_zone,
  					GFP_KERNEL);
  	if (!conf->hash_table)
***************
*** 87,93 ****
  			table[-1].dev1 = disk;
  		}
  		size += disk->size;
- 
  		while (size>0) {
  			table->dev0 = disk;
  			table->dev1 = NULL;
--- 98,103 ----
***************
*** 125,139 ****
          linear_conf_t *conf = mddev_to_conf(mddev);
          struct linear_hash *hash;
          dev_info_t *tmp_dev;
!         long block;
  
  	block = bh->b_rsector >> 1;
! 	hash = conf->hash_table + (block / conf->smallest->size);
    
  	if (block >= (hash->dev0->size + hash->dev0->offset)) {
  		if (!hash->dev1) {
! 			printk ("linear_make_request : hash->dev1==NULL for block %ld\n",
! 						block);
  			buffer_IO_error(bh);
  			return 0;
  		}
--- 135,155 ----
          linear_conf_t *conf = mddev_to_conf(mddev);
          struct linear_hash *hash;
          dev_info_t *tmp_dev;
!         sector_t block;
! 	sector_t hashindex;
  
  	block = bh->b_rsector >> 1;
! 
! 	BUG_ON((sector_t)block != ((sector_t)bh->b_rsector >> 1));
! 	
! 	hashindex = block;
! 	sector_div(hashindex, (long)conf->smallest->size);
! 	hash = conf->hash_table + hashindex;
    
  	if (block >= (hash->dev0->size + hash->dev0->offset)) {
  		if (!hash->dev1) {
! 			printk ("linear_make_request : hash->dev1==NULL for block %llu\n",
! 						(unsigned long long)block);
  			buffer_IO_error(bh);
  			return 0;
  		}
***************
*** 143,149 ****
      
  	if (block >= (tmp_dev->size + tmp_dev->offset)
  				|| block < tmp_dev->offset) {
! 		printk ("linear_make_request: Block %ld out of bounds on dev %s size %ld offset %ld\n", block, kdevname(tmp_dev->dev), tmp_dev->size, tmp_dev->offset);
  		buffer_IO_error(bh);
  		return 0;
  	}
--- 159,169 ----
      
  	if (block >= (tmp_dev->size + tmp_dev->offset)
  				|| block < tmp_dev->offset) {
! 		printk ("linear_make_request: Block %llu out of bounds on dev %s size %ld offset %ld\n", 
! 			(unsigned long long)block, 
! 			kdevname(tmp_dev->dev), 
! 			(long)tmp_dev->size, 
! 			(long)tmp_dev->offset);
  		buffer_IO_error(bh);
  		return 0;
  	}
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/lvm-snap.c linux-2.4.22-ashuariadevel/drivers/md/lvm-snap.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/lvm-snap.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/lvm-snap.c	2004-02-02 15:14:47.000000000 +0900
***************
*** 71,78 ****
  
  
  static inline int __brw_kiovec(int rw, int nr, struct kiobuf *iovec[],
! 			       kdev_t dev, unsigned long b[], int size,
! 			       lv_t *lv) {
  	return brw_kiovec(rw, nr, iovec, dev, b, size);
  }
  
--- 71,78 ----
  
  
  static inline int __brw_kiovec(int rw, int nr, struct kiobuf *iovec[],
! 			     kdev_t dev, sector_t b[], int size,
! 			     lv_t * lv) {
  	return brw_kiovec(rw, nr, iovec, dev, b, size);
  }
  
***************
*** 220,229 ****
  	       reason);
  }
  
! static inline int lvm_snapshot_prepare_blocks(unsigned long *blocks,
! 					       unsigned long start,
! 					       int nr_sectors,
! 					       int blocksize)
  {
  	int i, sectors_per_block, nr_blocks;
  
--- 220,229 ----
  	       reason);
  }
  
! static inline int lvm_snapshot_prepare_blocks(sector_t *blocks,
! 					    sector_t start,
! 					    int nr_sectors,
! 					    int blocksize)
  {
  	int i, sectors_per_block, nr_blocks;
  
***************
*** 233,239 ****
  		return 0;
  
  	nr_blocks = nr_sectors / sectors_per_block;
! 	start /= sectors_per_block;
  
  	for (i = 0; i < nr_blocks; i++)
  		blocks[i] = start++;
--- 233,239 ----
  		return 0;
  
  	nr_blocks = nr_sectors / sectors_per_block;
! 	sector_div(start, sectors_per_block);
  
  	for (i = 0; i < nr_blocks; i++)
  		blocks[i] = start++;
***************
*** 441,447 ****
  	unsigned long org_start, snap_start, snap_phys_dev, virt_start, pe_off;
  	int idx = lv_snap->lv_remap_ptr, chunk_size = lv_snap->lv_chunk_size;
  	struct kiobuf * iobuf = lv_snap->lv_iobuf;
! 	unsigned long *blocks = iobuf->blocks;
  	int blksize_snap, blksize_org, min_blksize, max_blksize;
  	int max_sectors, nr_sectors;
  
--- 441,447 ----
  	unsigned long org_start, snap_start, snap_phys_dev, virt_start, pe_off;
  	int idx = lv_snap->lv_remap_ptr, chunk_size = lv_snap->lv_chunk_size;
  	struct kiobuf * iobuf = lv_snap->lv_iobuf;
! 	sector_t *blocks = iobuf->blocks;
  	int blksize_snap, blksize_org, min_blksize, max_blksize;
  	int max_sectors, nr_sectors;
  
***************
*** 659,666 ****
  	int idx_COW_table;
  	uint pvn;
  	ulong snap_pe_start, COW_table_sector_offset,
! 	      COW_entries_per_pe, COW_chunks_per_pe, COW_entries_per_block;
! 	ulong blocks[1];
  	kdev_t snap_phys_dev;
  	lv_block_exception_t *be;
  	struct kiobuf *COW_table_iobuf = lv_snap->lv_COW_table_iobuf;
--- 659,666 ----
  	int idx_COW_table;
  	uint pvn;
  	ulong snap_pe_start, COW_table_sector_offset,
! 	    COW_entries_per_pe, COW_chunks_per_pe, COW_entries_per_block;
! 	sector_t blocks[1];
  	kdev_t snap_phys_dev;
  	lv_block_exception_t *be;
  	struct kiobuf *COW_table_iobuf = lv_snap->lv_COW_table_iobuf;
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/lvm.c linux-2.4.22-ashuariadevel/drivers/md/lvm.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/lvm.c	2003-12-09 11:52:21.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/lvm.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 427,433 ****
  static struct hd_struct lvm_hd_struct[MAX_LV];
  static int lvm_blocksizes[MAX_LV];
  static int lvm_hardsectsizes[MAX_LV];
! static int lvm_size[MAX_LV];
  
  static mempool_t *lvm_callback_mempool;
  
--- 427,433 ----
  static struct hd_struct lvm_hd_struct[MAX_LV];
  static int lvm_blocksizes[MAX_LV];
  static int lvm_hardsectsizes[MAX_LV];
! static sector_t lvm_size[MAX_LV];
  
  static mempool_t *lvm_callback_mempool;
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/md.c linux-2.4.22-ashuariadevel/drivers/md/md.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/md.c	2003-12-09 11:52:22.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/md.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 109,115 ****
  static int md_maxreadahead[MAX_MD_DEVS];
  static mdk_thread_t *md_recovery_thread;
  
! int md_size[MAX_MD_DEVS];
  
  static struct block_device_operations md_fops;
  static devfs_handle_t devfs_handle;
--- 109,115 ----
  static int md_maxreadahead[MAX_MD_DEVS];
  static mdk_thread_t *md_recovery_thread;
  
! sector_t md_size[MAX_MD_DEVS];
  
  static struct block_device_operations md_fops;
  static devfs_handle_t devfs_handle;
***************
*** 282,291 ****
  	return dname->name;
  }
  
! static unsigned int calc_dev_sboffset(kdev_t dev, mddev_t *mddev,
  						int persistent)
  {
! 	unsigned int size = 0;
  
  	if (blk_size[MAJOR(dev)])
  		size = blk_size[MAJOR(dev)][MINOR(dev)];
--- 282,291 ----
  	return dname->name;
  }
  
! static sector_t calc_dev_sboffset(kdev_t dev, mddev_t *mddev,
  						int persistent)
  {
! 	sector_t size = 0;
  
  	if (blk_size[MAJOR(dev)])
  		size = blk_size[MAJOR(dev)][MINOR(dev)];
***************
*** 294,302 ****
  	return size;
  }
  
! static unsigned int calc_dev_size(kdev_t dev, mddev_t *mddev, int persistent)
  {
! 	unsigned int size;
  
  	size = calc_dev_sboffset(dev, mddev, persistent);
  	if (!mddev->sb) {
--- 294,302 ----
  	return size;
  }
  
! static sector_t calc_dev_size(kdev_t dev, mddev_t *mddev, int persistent)
  {
! 	sector_t size;
  
  	size = calc_dev_sboffset(dev, mddev, persistent);
  	if (!mddev->sb) {
***************
*** 304,316 ****
  		return size;
  	}
  	if (mddev->sb->chunk_size)
! 		size &= ~(mddev->sb->chunk_size/1024 - 1);
  	return size;
  }
  
  static unsigned int zoned_raid_size(mddev_t *mddev)
  {
! 	unsigned int mask;
  	mdk_rdev_t * rdev;
  	struct md_list_head *tmp;
  
--- 304,316 ----
  		return size;
  	}
  	if (mddev->sb->chunk_size)
! 		size &= ~((sector_t)mddev->sb->chunk_size/1024 - 1);
  	return size;
  }
  
  static unsigned int zoned_raid_size(mddev_t *mddev)
  {
! 	sector_t mask;
  	mdk_rdev_t * rdev;
  	struct md_list_head *tmp;
  
***************
*** 321,327 ****
  	/*
  	 * do size and offset calculations.
  	 */
! 	mask = ~(mddev->sb->chunk_size/1024 - 1);
  
  	ITERATE_RDEV(mddev,rdev,tmp) {
  		rdev->size &= mask;
--- 321,327 ----
  	/*
  	 * do size and offset calculations.
  	 */
! 	mask = ~((sector_t)mddev->sb->chunk_size/1024 - 1);
  
  	ITERATE_RDEV(mddev,rdev,tmp) {
  		rdev->size &= mask;
***************
*** 331,337 ****
  }
  
  /*
!  * We check wether all devices are numbered from 0 to nb_dev-1. The
   * order is guaranteed even after device name changes.
   *
   * Some personalities (raid0, linear) use this. Personalities that
--- 331,337 ----
  }
  
  /*
!  * We check whether all devices are numbered from 0 to nb_dev-1. The
   * order is guaranteed even after device name changes.
   *
   * Some personalities (raid0, linear) use this. Personalities that
***************
*** 506,512 ****
  {
  	int ret = -EINVAL;
  	kdev_t dev = rdev->dev;
! 	unsigned long sb_offset;
  
  	if (!rdev->sb) {
  		MD_BUG();
--- 506,512 ----
  {
  	int ret = -EINVAL;
  	kdev_t dev = rdev->dev;
! 	sector_t sb_offset;
  
  	if (!rdev->sb) {
  		MD_BUG();
***************
*** 808,814 ****
  {
  	printk(KERN_INFO "md: rdev %s: O:%s, SZ:%08ld F:%d DN:%d ",
  		partition_name(rdev->dev), partition_name(rdev->old_dev),
! 		rdev->size, rdev->faulty, rdev->desc_nr);
  	if (rdev->sb) {
  		printk(KERN_INFO "md: rdev superblock:\n");
  		print_sb(rdev->sb);
--- 808,814 ----
  {
  	printk(KERN_INFO "md: rdev %s: O:%s, SZ:%08ld F:%d DN:%d ",
  		partition_name(rdev->dev), partition_name(rdev->old_dev),
! 		(long)rdev->size, rdev->faulty, rdev->desc_nr);
  	if (rdev->sb) {
  		printk(KERN_INFO "md: rdev superblock:\n");
  		print_sb(rdev->sb);
***************
*** 915,921 ****
  static int write_disk_sb(mdk_rdev_t * rdev)
  {
  	kdev_t dev;
! 	unsigned long sb_offset, size;
  
  	if (!rdev->sb) {
  		MD_BUG();
--- 915,921 ----
  static int write_disk_sb(mdk_rdev_t * rdev)
  {
  	kdev_t dev;
! 	sector_t sb_offset, size;
  
  	if (!rdev->sb) {
  		MD_BUG();
***************
*** 933,940 ****
  	dev = rdev->dev;
  	sb_offset = calc_dev_sboffset(dev, rdev->mddev, 1);
  	if (rdev->sb_offset != sb_offset) {
! 		printk(KERN_INFO "%s's sb offset has changed from %ld to %ld, skipping\n",
! 		       partition_name(dev), rdev->sb_offset, sb_offset);
  		goto skip;
  	}
  	/*
--- 933,940 ----
  	dev = rdev->dev;
  	sb_offset = calc_dev_sboffset(dev, rdev->mddev, 1);
  	if (rdev->sb_offset != sb_offset) {
! 		printk(KERN_INFO "%s's sb offset has changed from %llu to %llu, skipping\n",
! 		       partition_name(dev), (unsigned long long)rdev->sb_offset, (unsigned long long)sb_offset);
  		goto skip;
  	}
  	/*
***************
*** 944,955 ****
  	 */
  	size = calc_dev_size(dev, rdev->mddev, 1);
  	if (size != rdev->size) {
! 		printk(KERN_INFO "%s's size has changed from %ld to %ld since import, skipping\n",
! 		       partition_name(dev), rdev->size, size);
  		goto skip;
  	}
  
! 	printk(KERN_INFO "(write) %s's sb offset: %ld\n", partition_name(dev), sb_offset);
  
  	if (!sync_page_io(dev, sb_offset<<1, MD_SB_BYTES, rdev->sb_page, WRITE)) {
  		printk("md: write_disk_sb failed for device %s\n", partition_name(dev));
--- 944,957 ----
  	 */
  	size = calc_dev_size(dev, rdev->mddev, 1);
  	if (size != rdev->size) {
! 		printk(KERN_INFO "%s's size has changed from %llu to %llu since import, skipping\n",
! 		       partition_name(dev), 
! 		       (unsigned long long)rdev->size, 
! 		       (unsigned long long)size);
  		goto skip;
  	}
  
! 	printk(KERN_INFO "(write) %s's sb offset: %llu\n", partition_name(dev), (unsigned long long)sb_offset);
  
  	if (!sync_page_io(dev, sb_offset<<1, MD_SB_BYTES, rdev->sb_page, WRITE)) {
  		printk("md: write_disk_sb failed for device %s\n", partition_name(dev));
***************
*** 1084,1090 ****
  {
  	int err;
  	mdk_rdev_t *rdev;
! 	unsigned int size;
  
  	if (find_rdev_all(newdev))
  		return -EEXIST;
--- 1086,1092 ----
  {
  	int err;
  	mdk_rdev_t *rdev;
! 	sector_t size;
  
  	if (find_rdev_all(newdev))
  		return -EEXIST;
***************
*** 1549,1557 ****
  		rdev->size = calc_dev_size(rdev->dev, mddev, persistent);
  		if (rdev->size < sb->chunk_size / 1024) {
  			printk(KERN_WARNING
! 				"md: Dev %s smaller than chunk_size: %ldk < %dk\n",
  				partition_name(rdev->dev),
! 				rdev->size, sb->chunk_size / 1024);
  			return -EINVAL;
  		}
  	}
--- 1551,1559 ----
  		rdev->size = calc_dev_size(rdev->dev, mddev, persistent);
  		if (rdev->size < sb->chunk_size / 1024) {
  			printk(KERN_WARNING
! 				"md: Dev %s smaller than chunk_size: %lluk < %dk\n",
  				partition_name(rdev->dev),
! 				(unsigned long long)rdev->size, sb->chunk_size / 1024);
  			return -EINVAL;
  		}
  	}
***************
*** 2193,2199 ****
  
  static int add_new_disk(mddev_t * mddev, mdu_disk_info_t *info)
  {
! 	int err, size, persistent;
  	mdk_rdev_t *rdev;
  	unsigned int nr;
  	kdev_t dev;
--- 2195,2202 ----
  
  static int add_new_disk(mddev_t * mddev, mdu_disk_info_t *info)
  {
! 	int err, persistent;
! 	sector_t size;
  	mdk_rdev_t *rdev;
  	unsigned int nr;
  	kdev_t dev;
***************
*** 2380,2386 ****
  static int hot_add_disk(mddev_t * mddev, kdev_t dev)
  {
  	int i, err, persistent;
! 	unsigned int size;
  	mdk_rdev_t *rdev;
  	mdp_disk_t *disk;
  
--- 2383,2389 ----
  static int hot_add_disk(mddev_t * mddev, kdev_t dev)
  {
  	int i, err, persistent;
! 	sector_t size;
  	mdk_rdev_t *rdev;
  	mdp_disk_t *disk;
  
***************
*** 2421,2428 ****
  	size = calc_dev_size(dev, mddev, persistent);
  
  	if (size < mddev->sb->size) {
! 		printk(KERN_WARNING "md%d: disk size %d blocks < array size %d\n",
! 				mdidx(mddev), size, mddev->sb->size);
  		err = -ENOSPC;
  		goto abort_export;
  	}
--- 2424,2432 ----
  	size = calc_dev_size(dev, mddev, persistent);
  
  	if (size < mddev->sb->size) {
! 		printk(KERN_WARNING "md%d: disk size %llu blocks < array size %llu\n",
! 		       mdidx(mddev), (unsigned long long)size,
! 		       (unsigned long long)mddev->sb->size);
  		err = -ENOSPC;
  		goto abort_export;
  	}
***************
*** 2864,2870 ****
  
  		default:
  			printk(KERN_WARNING "md: %s(pid %d) used obsolete MD ioctl, "
! 			       "upgrade your software to use new ictls.\n",
  			       current->comm, current->pid);
  			err = -EINVAL;
  			goto abort_unlock;
--- 2868,2874 ----
  
  		default:
  			printk(KERN_WARNING "md: %s(pid %d) used obsolete MD ioctl, "
! 			       "upgrade your software to use new ioctls.\n",
  			       current->comm, current->pid);
  			err = -EINVAL;
  			goto abort_unlock;
***************
*** 3253,3262 ****
  
  	if (mddev->nb_dev) {
  		if (mddev->pers)
! 			seq_printf(seq, "\n      %d blocks",
! 				   md_size[mdidx(mddev)]);
  		else
! 			seq_printf(seq, "\n      %d blocks", size);
  	}
  
  	if (mddev->pers) {
--- 3257,3266 ----
  
  	if (mddev->nb_dev) {
  		if (mddev->pers)
! 			seq_printf(seq, "\n      %llu blocks",
! 				   (unsigned long long)md_size[mdidx(mddev)]);
  		else
! 			seq_printf(seq, "\n      %llu blocks", (unsigned long long)size);
  	}
  
  	if (mddev->pers) {
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/multipath.c linux-2.4.22-ashuariadevel/drivers/md/multipath.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/multipath.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/multipath.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 216,223 ****
  	/*
  	 * oops, IO error:
  	 */
! 	printk(KERN_ERR "multipath: %s: rescheduling block %lu\n", 
! 		 partition_name(bh->b_dev), bh->b_blocknr);
  	multipath_reschedule_retry(mp_bh);
  	return;
  }
--- 216,223 ----
  	/*
  	 * oops, IO error:
  	 */
! 	printk(KERN_ERR "multipath: %s: rescheduling block %llu\n", 
! 		 partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  	multipath_reschedule_retry(mp_bh);
  	return;
  }
***************
*** 669,678 ****
  
  
  #define IO_ERROR KERN_ALERT \
! "multipath: %s: unrecoverable IO read error for block %lu\n"
  
  #define REDIRECT_SECTOR KERN_ERR \
! "multipath: %s: redirecting sector %lu to another IO path\n"
  
  /*
   * This is a kernel thread which:
--- 669,678 ----
  
  
  #define IO_ERROR KERN_ALERT \
! "multipath: %s: unrecoverable IO read error for block %llu\n"
  
  #define REDIRECT_SECTOR KERN_ERR \
! "multipath: %s: redirecting sector %llu to another IO path\n"
  
  /*
   * This is a kernel thread which:
***************
*** 707,717 ****
  		
  		multipath_map (mddev, &bh->b_dev);
  		if (bh->b_dev == dev) {
! 			printk (IO_ERROR, partition_name(bh->b_dev), bh->b_blocknr);
  			multipath_end_bh_io(mp_bh, 0);
  		} else {
  			printk (REDIRECT_SECTOR,
! 				partition_name(bh->b_dev), bh->b_blocknr);
  			bh->b_rdev = bh->b_dev;
  			bh->b_rsector = bh->b_blocknr;
  			generic_make_request (mp_bh->cmd, bh);
--- 707,717 ----
  		
  		multipath_map (mddev, &bh->b_dev);
  		if (bh->b_dev == dev) {
! 			printk (IO_ERROR, partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  			multipath_end_bh_io(mp_bh, 0);
  		} else {
  			printk (REDIRECT_SECTOR,
! 				partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  			bh->b_rdev = bh->b_dev;
  			bh->b_rsector = bh->b_blocknr;
  			generic_make_request (mp_bh->cmd, bh);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/raid0.c linux-2.4.22-ashuariadevel/drivers/md/raid0.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/raid0.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/raid0.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 41,47 ****
  		printk("raid0: looking at %s\n", partition_name(rdev1->dev));
  		c = 0;
  		ITERATE_RDEV_ORDERED(mddev,rdev2,j2) {
! 			printk("raid0:   comparing %s(%ld) with %s(%ld)\n", partition_name(rdev1->dev), rdev1->size, partition_name(rdev2->dev), rdev2->size);
  			if (rdev2 == rdev1) {
  				printk("raid0:   END\n");
  				break;
--- 41,50 ----
  		printk("raid0: looking at %s\n", partition_name(rdev1->dev));
  		c = 0;
  		ITERATE_RDEV_ORDERED(mddev,rdev2,j2) {
! 			printk("raid0:   comparing %s(%llu) with %s(%llu)\n", partition_name(rdev1->dev),
! 			       (unsigned long long)rdev1->size, 
! 			       partition_name(rdev2->dev), 
! 			       (unsigned long long)rdev2->size);
  			if (rdev2 == rdev1) {
  				printk("raid0:   END\n");
  				break;
***************
*** 95,101 ****
  				c++;
  				if (!smallest || (rdev->size <smallest->size)) {
  					smallest = rdev;
! 					printk("  (%ld) is smallest!.\n", rdev->size);
  				}
  			} else
  				printk(" nope.\n");
--- 98,104 ----
  				c++;
  				if (!smallest || (rdev->size <smallest->size)) {
  					smallest = rdev;
! 					printk("  (%llu) is smallest!.\n", (unsigned long long)rdev->size);
  				}
  			} else
  				printk(" nope.\n");
***************
*** 120,126 ****
  
  static int raid0_run (mddev_t *mddev)
  {
! 	unsigned long cur=0, i=0, size, zone0_size, nb_zone;
  	raid0_conf_t *conf;
  
  	MOD_INC_USE_COUNT;
--- 123,130 ----
  
  static int raid0_run (mddev_t *mddev)
  {
! 	unsigned long cur=0, i=0, zone0_size, nb_zone;
! 	sector_t size;
  	raid0_conf_t *conf;
  
  	MOD_INC_USE_COUNT;
***************
*** 138,150 ****
  	if (create_strip_zones (mddev)) 
  		goto out_free_conf;
  
! 	printk("raid0 : md_size is %d blocks.\n", md_size[mdidx(mddev)]);
  	printk("raid0 : conf->smallest->size is %ld blocks.\n", conf->smallest->size);
- 	nb_zone = md_size[mdidx(mddev)]/conf->smallest->size +
- 			(md_size[mdidx(mddev)] % conf->smallest->size ? 1 : 0);
- 	printk("raid0 : nb_zone is %ld.\n", nb_zone);
- 	conf->nr_zones = nb_zone;
  
  	printk("raid0 : Allocating %ld bytes for hash.\n",
  				nb_zone*sizeof(struct raid0_hash));
  
--- 142,159 ----
  	if (create_strip_zones (mddev)) 
  		goto out_free_conf;
  
! 	printk("raid0 : md_size is %llu blocks.\n", (unsigned long long)md_size[mdidx(mddev)]);
  	printk("raid0 : conf->smallest->size is %ld blocks.\n", conf->smallest->size);
  
+ 	{
+ #if __GNUC__ < 3 /* work around bug in gcc 2.9[56] */
+ 		volatile 
+ #endif
+ 			sector_t sz = md_size[mdidx(mddev)];
+ 		unsigned round = sector_div(sz, conf->smallest->size);
+ 		conf->nr_zones = nb_zone =  sz + (round != 0);
+ 	}
+ 	printk("raid0 : nb_zone is %ld.\n", nb_zone);
  	printk("raid0 : Allocating %ld bytes for hash.\n",
  				nb_zone*sizeof(struct raid0_hash));
  
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/md/raid1.c linux-2.4.22-ashuariadevel/drivers/md/raid1.c
*** linux-2.4.22-ashuariadevel.backup/drivers/md/raid1.c	2003-06-13 23:51:34.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/md/raid1.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 441,448 ****
  		/*
  		 * oops, read error:
  		 */
! 		printk(KERN_ERR "raid1: %s: rescheduling block %lu\n", 
! 			 partition_name(bh->b_dev), bh->b_blocknr);
  		raid1_reschedule_retry(r1_bh);
  		return;
  	}
--- 441,448 ----
  		/*
  		 * oops, read error:
  		 */
! 		printk(KERN_ERR "raid1: %s: rescheduling block %llu\n", 
! 			 partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  		raid1_reschedule_retry(r1_bh);
  		return;
  	}
***************
*** 1136,1145 ****
  
  
  #define IO_ERROR KERN_ALERT \
! "raid1: %s: unrecoverable I/O read error for block %lu\n"
  
  #define REDIRECT_SECTOR KERN_ERR \
! "raid1: %s: redirecting sector %lu to another mirror\n"
  
  /*
   * This is a kernel thread which:
--- 1136,1145 ----
  
  
  #define IO_ERROR KERN_ALERT \
! "raid1: %s: unrecoverable I/O read error for block %llu\n"
  
  #define REDIRECT_SECTOR KERN_ERR \
! "raid1: %s: redirecting sector %llu to another mirror\n"
  
  /*
   * This is a kernel thread which:
***************
*** 1250,1256 ****
  				 * as reconstruct is about to be aborted
  				 */
  
! 				printk (IO_ERROR, partition_name(bh->b_dev), bh->b_blocknr);
  				md_done_sync(mddev, bh->b_size>>9, 0);
  			}
  
--- 1250,1256 ----
  				 * as reconstruct is about to be aborted
  				 */
  
! 				printk (IO_ERROR, partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  				md_done_sync(mddev, bh->b_size>>9, 0);
  			}
  
***************
*** 1260,1270 ****
  			dev = bh->b_dev;
  			raid1_map (mddev, &bh->b_dev);
  			if (bh->b_dev == dev) {
! 				printk (IO_ERROR, partition_name(bh->b_dev), bh->b_blocknr);
  				raid1_end_bh_io(r1_bh, 0);
  			} else {
  				printk (REDIRECT_SECTOR,
! 					partition_name(bh->b_dev), bh->b_blocknr);
  				bh->b_rdev = bh->b_dev;
  				bh->b_rsector = bh->b_blocknr;
  				generic_make_request (r1_bh->cmd, bh);
--- 1260,1270 ----
  			dev = bh->b_dev;
  			raid1_map (mddev, &bh->b_dev);
  			if (bh->b_dev == dev) {
! 				printk (IO_ERROR, partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  				raid1_end_bh_io(r1_bh, 0);
  			} else {
  				printk (REDIRECT_SECTOR,
! 					partition_name(bh->b_dev), (unsigned long long)bh->b_blocknr);
  				bh->b_rdev = bh->b_dev;
  				bh->b_rsector = bh->b_blocknr;
  				generic_make_request (r1_bh->cmd, bh);
diff -Ncr linux-2.4.22-ashuariadevel.backup/drivers/message/i2o/i2o_block.c linux-2.4.22-ashuariadevel/drivers/message/i2o/i2o_block.c
*** linux-2.4.22-ashuariadevel.backup/drivers/message/i2o/i2o_block.c	2002-08-03 09:39:44.000000000 +0900
--- linux-2.4.22-ashuariadevel/drivers/message/i2o/i2o_block.c	2004-02-02 14:35:09.000000000 +0900
***************
*** 125,131 ****
  
  static int i2ob_blksizes[MAX_I2OB<<4];
  static int i2ob_hardsizes[MAX_I2OB<<4];
! static int i2ob_sizes[MAX_I2OB<<4];
  static int i2ob_media_change_flag[MAX_I2OB];
  static u32 i2ob_max_sectors[MAX_I2OB<<4];
  
--- 125,131 ----
  
  static int i2ob_blksizes[MAX_I2OB<<4];
  static int i2ob_hardsizes[MAX_I2OB<<4];
! static sector_t i2ob_sizes[MAX_I2OB<<4];
  static int i2ob_media_change_flag[MAX_I2OB];
  static u32 i2ob_max_sectors[MAX_I2OB<<4];
  
